/* lapack_link/proto.h.  Generated automatically by configure.  */
/*
    This file is part of the Cheap Matrix library
    Copyright (C) 2000  Nicolas Brodu
    nicolas.brodu@free.fr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/
#ifndef PROTO_H_CHEAP_MATRIX
#define PROTO_H_CHEAP_MATRIX

#define PROTOTYPE_LOWER_   0
#define PROTOTYPE_LOWER    1
#define PROTOTYPE_LOWER__  2
#define _PROTOTYPE_LOWER   3
#define __PROTOTYPE_LOWER  4
#define PROTOTYPE_UPPER_   5
#define PROTOTYPE_UPPER    6
#define PROTOTYPE_UPPER__  7
#define _PROTOTYPE_UPPER   8
#define __PROTOTYPE_UPPER  9

#define LAPACK_PROTOTYPE PROTOTYPE_LOWER_

#if LAPACK_PROTOTYPE==PROTOTYPE_LOWER
#define PROTO(a,b) a
#endif
#if LAPACK_PROTOTYPE==PROTOTYPE_LOWER_
#define PROTO(a,b) a ## _
#endif
#if LAPACK_PROTOTYPE==PROTOTYPE_LOWER__
#define PROTO(a,b) a ## __
#endif
#if LAPACK_PROTOTYPE==_PROTOTYPE_LOWER
#define PROTO(a,b) _ ## a
#endif
#if LAPACK_PROTOTYPE==__PROTOTYPE_LOWER
#define PROTO(a,b) __ ## a
#endif
#if LAPACK_PROTOTYPE==PROTOTYPE_UPPER
#define PROTO(a,b) b
#endif
#if LAPACK_PROTOTYPE==PROTOTYPE_UPPER_
#define PROTO(a,b) b ## _
#endif
#if LAPACK_PROTOTYPE==PROTOTYPE_UPPER__
#define PROTO(a,b) b ## __
#endif
#if LAPACK_PROTOTYPE==_PROTOTYPE_UPPER
#define PROTO(a,b) _ ## b
#endif
#if LAPACK_PROTOTYPE==__PROTOTYPE_UPPER
#define PROTO(a,b) __ ## b
#endif

#ifdef NDEBUG
#ifndef CERR
#define CERR(a)
#endif
#else
#ifndef CERR
#define CERR(a) cerr << a
#endif
#endif

#define CHECK_DIM(id,mat,r,c) \
	if ( ## mat ## .rows()!= ## r ##  ||  ## mat ## .cols()!= ## c ## ) { \
		CERR(#id": dimensions of "#mat" do not match ("<< ## r ## <<","<< ## c ## <<")."<<endl); \
		return false; \
	}

#define CHECK_NOT_REF(id,mat1,mat2) \
	if ( ## mat1 ## .equal_ref( ## mat2 ## )) { \
		CERR(#id": Unsupported: "#mat1" and "#mat2" reference the same data."<<endl); \
		return false; \
	}

#define CHECK_MEM_LEAD(id,mat,lead) \
	integer lead;\
	if (!( ## lead ## = ## mat ## .contiguous())) { \
		CERR(#id": "#mat" is not contiguous."<<endl); \
		return false; \
	} \
	if (! ## mat ## .hold()) { \
		CERR(#id": "#mat" doesn't fit in memory.."<<endl); \
		return false; \
	}
#define CHECK_MEM(id,mat) \
	if (! ## mat ## .contiguous()) { \
		CERR(#id": "#mat" is not contiguous."<<endl); \
		return false; \
	} \
	if (! ## mat ## .hold()) { \
		CERR(#id" : "#mat" doesn't fit in memory.."<<endl); \
		return false; \
	}
#define ALLOCATE_WORK(id,size) \
	integer lwork = ## size ## ; \
	doublereal* work = new doublereal[lwork]; \
	if (!work) { \
		CERR(#id": cannot allocate "<<lwork*sizeof(doublereal)<<" bytes for LAPACK workspace."<<endl); \
		return false; \
	}


#endif //PROTO_H_CHEAP_MATRIX
